# TODO:
#	SBC plugin is missing bluez_sbc subdir
#	fix static libname (libopal_s.a)
#	MPEG4 rate control correction requires libavcodec sources
# NOTE: IPv6 support requires IPv6 support in ptlib
#
# WARNING: opal version should match Ekiga and ptlib versions
#	Recommendations: http://wiki.ekiga.org/index.php/Download_Ekiga_sources
#	(for ekiga 4.0.x it's ptlib 2.10.x + opal 3.10.x)
#
# Conditional build:
%bcond_with	sip_fax_only	# minimal build for t38modem + SIP
%bcond_without	celt		# CELT codec support
%bcond_without	srtp		# SRTP protocol support (mutually exclusive with zrtp)
%bcond_with	zrtp		# ZRTP protocol support (mutually exclusive with srtp; broken as of 3.10.9)
%bcond_with	capi		# CAPI support
%bcond_with	vpb		# Voicetronix VPB support
%bcond_with	java		# Java JNI interface (only swig wrapper, Java part not built)
%bcond_with	ruby		# Ruby interface (very initial, only swig wrapper)
#
%if %{with zrtp}
%undefine	with_srtp
%endif
%if %{with sip_fax_only}
%undefine	with_java
%undefine	with_ruby
%undefine	with_srtp
%undefine	with_zrtp
%endif
Summary:	Open Phone Abstraction Library (aka OpenH323 v2)
Summary(pl.UTF-8):	Biblioteka Open Phone Abstraction Library (aka OpenH323 v2)
Name:		opal
Version:	3.18.6
Release:	2
License:	MPL v1.0
Group:		Libraries
Source0:	http://downloads.sourceforge.net/opalvoip/%{name}-%{version}.tar.bz2
# Source0-md5:	0b4dfe603834b3cf2252782f1594403d
Patch0:		celt.patch
Patch1:		g7221.patch
URL:		http://www.opalvoip.org/
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake
%{?with_capi:BuildRequires:	capi4k-utils-devel}
%{?with_celt:BuildRequires:	celt-devel}
BuildRequires:	expat-devel
%{?with_srtp:BuildRequires:	libsrtp2-devel}
BuildRequires:	libstdc++-devel
%{?with_zrtp:BuildRequires:	libzrtp-devel}
BuildRequires:	pkgconfig
BuildRequires:	ptlib-devel >= 1:2.18.5
BuildRequires:	sed >= 4.0
BuildRequires:	speex-devel >= 1:1.2
BuildRequires:	speexdsp-devel >= 1.2
%if %{without sip_fax_only}
BuildRequires:	SDL-devel
# libavcodec >= 51.11.0 libavutil
BuildRequires:	ffmpeg-devel
%{?with_java:BuildRequires:	jdk}
BuildRequires:	libgsm-devel
BuildRequires:	libtheora-devel
%{?with_vpb:BuildRequires:	vpb-devel}
# ABI 0.102
BuildRequires:	libx264-devel >= 0.1.3-1.20101031_2245.1
BuildRequires:	openssl-devel
%{?with_ruby:BuildRequires:	ruby-devel}
BuildRequires:	spandsp-devel
BuildRequires:	swig
BuildRequires:	unixODBC-devel
BuildRequires:	webrtc-libilbc-devel
%endif
BuildConflicts:	dahdi-linux-devel
%requires_eq	ptlib
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The OPAL project aims to create a full featured, interoperable, Open
Source implementation of the ITU H.323 teleconferencing protocol that
can be used by personal developers and commercial users without
charge.

%description -l pl.UTF-8
Celem projektu OPAL jest stworzenie w pełni funkcjonalnej i
wyposażonej implementacji protokołu telekonferencyjnego ITU H.323,
który może być używany przez użytkowników prywatnych i komercyjnych
bez opłat.

%package lid-vpb
Summary:	Opal LID plugin for Voicetronix VPB devices
Summary(pl.UTF-8):	Wtyczka Opal LID dla urządzeń VPB firmy Voicetronix
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description lid-vpb
Opal LID plugin for Voicetronix VPB devices.

%description lid-vpb -l pl.UTF-8
Wtyczka Opal LID dla urządzeń VPB firmy Voicetronix.

%package devel
Summary:	Opal development files
Summary(pl.UTF-8):	Pliki dla developerów Opal
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%{?with_capi:Requires: capi4k-utils-devel}
%{?with_srtp:Requires: libsrtp2-devel}
Requires:	libstdc++-devel
%{?with_zrtp:Requires: libzrtp-devel}
Requires:	ptlib-devel >= 1:2.18.5
Requires:	speex-devel >= 1:1.2

%description devel
Header files and libraries for developing applications that use OPAL.

%description devel -l pl.UTF-8
Pliki nagłówkowe i biblioteki konieczne do rozwoju aplikacji
używających OPAL.

%package static
Summary:	OPAL static libraries
Summary(pl.UTF-8):	Biblioteki statyczne OPAL
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
OPAL static libraries.

%description static -l pl.UTF-8
Biblioteki statyczne OPAL.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
PWLIBDIR=%{_prefix}; export PWLIBDIR
OPALDIR=`pwd`; export OPALDIR
OPAL_BUILD="yes"; export OPAL_BUILD
cd plugins
%{__aclocal}
%{__autoconf}
cd ..
# Run  grep '^OPAL_.*=' configure.ac|grep 'yes\|no'  to check current defaults
%configure \
	%{?with_java:JDK_ROOT=%{_jvmdir}/java} \
%if %{with sip_fax_only}
	--disable-aec \
	--disable-g711plc \
	--disable-h224 \
	--disable-h281 \
	--disable-h323 \
	--disable-h450 \
	--disable-h460 \
	--disable-h501 \
	--disable-iax \
	--disable-ivr \
	--disable-lid \
	--disable-plugins
	--disable-rfc4103 \
	--disable-rfc4175 \
	--disable-sipim \
	--disable-video \
%else
	--enable-ixj \
%endif
	%{!?with_capi:--disable-capi} \
	%{!?with_celt:--disable-celt} \
	%{!?with_java:--disable-java} \
	%{!?with_ruby:--disable-ruby} \
	%{!?with_srtp:--disable-srtp} \
	%{?with_vpb:--enable-vpb} \
%if %{with zrtp}
	--enable-zrtp \
	--with-bn-includedir=/usr/include \
	--with-bn-libdir=%{_libdir} \
	--with-zrtp-includedir=/usr/include/libzrtp \
	--with-zrtp-libdir=%{_libdir}
%endif

%{__make} %{?debug:debug}%{!?debug:opt} \
	CC="%{__cc}" \
	CPLUS="%{__cxx}" \
	OPTCCFLAGS="%{rpmcflags} %{!?debug:-DNDEBUG}" \
	VERBOSE=1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_libdir}/opal-%{version}/lid

%{__make} install \
        DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libopal.so.%{version}
%if %{without sip_fax_only}
%dir %{_libdir}/opal-%{version}
%dir %{_libdir}/opal-%{version}/codecs
%dir %{_libdir}/opal-%{version}/codecs/audio
%{?with_celt:%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/celt_ptplugin.so}
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/g7221_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/g7222_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/g722_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/g726_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/gsm0610_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/gsmamrcodec_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/iLBC_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/ima_adpcm_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/iSAC_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/lpc10_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/opus_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/silk_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/audio/speex_ptplugin.so
%dir %{_libdir}/opal-%{version}/codecs/video
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/video/h261_vic_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/video/h263_ffmpeg_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/video/h264_video_pwplugin_helper
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/video/h264_x264_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/video/mpeg4_ffmpeg_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/video/theora_ptplugin.so
%attr(755,root,root) %{_libdir}/opal-%{version}/codecs/video/vp8_webm_ptplugin.so
%dir %{_libdir}/opal-%{version}/fax
%attr(755,root,root) %{_libdir}/opal-%{version}/fax/spandsp_ptplugin.so
%endif
%dir %{_libdir}/opal-%{version}/lid

%if %{with vpb}
%files lid-vpb
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/opal-%{version}/lid/vpb_ptplugin.so
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libopal.so
%{_includedir}/opal
%{_pkgconfigdir}/opal.pc
%{_datadir}/opal

%files static
%defattr(644,root,root,755)
%{_libdir}/libopal_s.a
%changelog
* Sun Feb 14 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/opal.git;a=log;h=master

* Sun Feb 14 2021 Jan Rękorajski <baggins@pld-linux.org> 279b44c
- make devel package own daatdir/opal dir, nothing else there
- rel 2

* Sun Feb 14 2021 Jan Rękorajski <baggins@pld-linux.org> 27672b9
- rel 1

* Sun Feb 14 2021 Jan Rękorajski <baggins@pld-linux.org> 00728d8
- dahdi and vpb support is completely broken, disabled
- updated files

* Sun Feb 14 2021 Jan Rękorajski <baggins@pld-linux.org> 7b0f56b
- lid does still exist but required dahdi-linux-devel to build

* Sat Feb 13 2021 Jan Rękorajski <baggins@pld-linux.org> c978936
- updated to 3.18.6

* Sun Apr 26 2020 Jan Rękorajski <baggins@pld-linux.org> d0b57f6
- release 7 (by relup.sh)

* Sun Apr 26 2020 Jan Rękorajski <baggins@pld-linux.org> 764c99c
- disable capi, isdn4-utils is dead and gone

* Mon Jan 14 2019 Jan Palus <atler@pld-linux.org> b698c11
- libx264 rebuild
- release 6 (by relup.sh)

* Sun Sep 30 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> ec6cdc1
- rel 5; add lid dir

* Sat Sep 29 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> a4d4299
- rel 4; ffmpeg fixes from freebsd

* Thu Sep 27 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 8d7f756
- use libsrtp2 instead of srtp; partial ffmpeg update

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> ce6899e
- release 3 (by relup.sh)

* Tue Oct 06 2015 Jan Rękorajski <baggins@pld-linux.org> c547d39
- release 2 (by relup.sh)

* Mon Aug 03 2015 Jakub Bogusz <qboosh@pld-linux.org> b3e5ac6
- updated to 3.10.11

* Sun Aug 02 2015 Jan Rękorajski <baggins@pld-linux.org> 2ded7ee
- release 5 (by relup.sh)

* Sun Aug 02 2015 Jan Rękorajski <baggins@pld-linux.org> daa42b5
- adapt libilbc patch to webrtc-libilbc 2.0.x

* Sun Apr 12 2015 Jan Rękorajski <baggins@pld-linux.org> 70d9e80
- x32 rebuild
- release 4 (by relup.sh)

* Sun Jan 25 2015 Jakub Bogusz <qboosh@pld-linux.org> 63a4e76
- speexdsp has no epoch

* Sun Jan 25 2015 Jakub Bogusz <qboosh@pld-linux.org> 474e68a
- BR: speexdsp-devel

* Sat Mar 29 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> b8d5926
- x264 rebuild
- release 3 (by relup.sh)

